"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.groupByNodeSignatureType = groupByNodeSignatureType;
exports.sortSignatureType = sortSignatureType;
function _semanticsEntities() {
  const data = require("@teambit/semantics.entities.semantic-schema");
  _semanticsEntities = function () {
    return data;
  };
  return data;
}
function _pluralize() {
  const data = _interopRequireDefault(require("pluralize"));
  _pluralize = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function sortSignatureType([aType], [bType]) {
  if (!aType) return -1;
  if (!bType) return 1;
  if (aType === 'constructors') return -1;
  if (bType === 'constructors') return 1;
  if (aType === 'properties') return -1;
  if (bType === 'properties') return 1;
  if (aType < bType) return -1;
  if (aType > bType) return 1;
  return 0;
}
function groupByNodeSignatureType(nodes) {
  return nodes.reduce((acc, next) => {
    const {
      signature,
      __schema
    } = next;
    if (!signature) return acc;
    let type;
    if (__schema === _semanticsEntities().ConstructorSchema.name) {
      type = (0, _pluralize().default)('constructor');
    }
    if (!type && signature.startsWith('(') && signature.includes('):')) {
      type = (0, _pluralize().default)('method');
    }
    if (!type && signature.startsWith('[') && signature.includes(']:')) {
      type = (0, _pluralize().default)('property');
    }
    if (!type) {
      const extractedType = signature.split(') ')[0].split('(')[1];
      type = extractedType ? (0, _pluralize().default)(extractedType) : undefined;
    }
    const existing = acc.get(type) || [];
    acc.set(type, existing.concat(next));
    return acc;
  }, new Map());
}

//# sourceMappingURL=group-schema-node-by-signature.js.map